	.model tiny
	.586p
	.radix 10
dataseg

sdelzp  db      'Zadajte text spravy: $'
sdel1   db      'NetAPI Program neni instalovany ',10,13,'$'
sdel2   db      'Nie je mozne otvorit IPX soket',10,13,'$'
sdel3   db      'Nastala chyba siete ',10,13,'$'

usedsocket   =    5555h                ;definuje slo soketu pouzitho
                                       ;v programe
ECB    struc                           ;definicia struktury ECB bloku
       Link         dd      0
       ESR          dd      0
       InUse        db      0
       CompCod      db      0
       socket       dw      usedsocket
       IPXwspc      db      4 dup (0)
       DRVwspc      db      12 dup (0)
       LocNoAd      db      6 dup (0FFh)
       FragCnt      dw      1h
       FragDta      dw      0
                    dw      0
       FragSiz      dw      200
ECB       ends

IPXhead  struc
       checksum     dw      0FFFFh
       length_h     dw      0
       transpctrl   db      0
       packettype   db      0
       destnetw     db      4 dup (0)
       destnode     db      6 dup (0FFh)
       destsckt     dw      usedsocket
       srcenetw     db      4 dup (0)
       srcenode     db      6 dup (0FFh)
       srcesckt     dw      usedsocket

IPXhead ends

STEJNESEG MACRO				
       mov         ax,cs		;makro nastavi podla registru CS
       mov         ds,ax		;oba segmentove registre DS a SS
       mov         es,ax		;Neviem ale preco, lebo TASM ich
       ENDM				;nsatavi automaticky

       ORG 100H				;Prekladam od absolutnej adresy 100h

codeseg					;Nadol je uz kod programu

startupcode

Run:      jmp     worker		;Skok na vykonavanie programu

ECBs   ECB  <,,,,,,,,,offset IPXs,,>	;inicializacia bloku ECB

IPXs     IPXhead  <>			;Inicializacia IPX hlavicky
delkaS   db       255			;Tu zacinaju data odosielaneho paketu
sdelkas  db       0
dataS    db       532 dup (0)		;Maximalna dlzka je 534 byte

totoPSP  dw       0			;Tu sa uchovava segment programu

worker:  STEJNESEG			;Nastavim DS=ES=CS registre
         mov      ax,7A00h		;Zistujem ci je nainstalovane API
         int      2Fh			
         mov      dx,offset sdel1	;Do registra DX pripravim adresu oznamenia
         cmp      al,0FFh		;a ak nie je tak ohlasim chybu
         je       install		;IPX je instalovane, tak skacem
         jmp      error			;Skok na ohlasenie chyby

install:mov       al,0			;Otvorenie soketu typ 'short live'
        mov       bx,0			;Sluzba otvorenia soketu
        mov       dx,usedsocket		;daj cislo soketu do DX
        int       7Ah			
        mov       dx,offset sdel2	
        cmp       al,0			;Ak nejde otvorit
        jne       error			;ohlas chybu

        mov       ah,62h		;Zisti PSP tohoto programu
        int       21h			;
        mov       totoPSP,bx		;Uloz ich do svojej premennej
        mov       ECBs.FragDta+2,bx	;a uloz ich do segmentu popisovaca fragmentu dat

        STEJNESEG
        mov      dx,offset sdelzp	;Pozaduj o zadanie retazca
        mov      ah,09h			;z klavesnice
        int      21h			;Vypisem hlasku
        mov      delkas,255		;Nastavujem dlzku zadavaneho retazca
        mov      dx,offset delkas	;a jeho adresu v pamati
        mov      ah,0Ah			;Sluzba DOSu 11 - Zadaj retazec
        int      21h			;Zadaj text do bufferu
        mov      al,sdelkas		;Do AL si daj jeho dlzku
        xor      ah,ah			;a zisti si jeho skutocnu dlzku
        inc      ax			;zadaneho retazca a daj ho do AX
        mov      cx,ax			;a tiez do CX
        mov      si,offset DataS	;Uprav si data pre vysielanie
        mov      di,offset delkas	;kopirovanie retazca na zaciatok
        rep movsb			;oblasti dat v pakete
        add      ax,30			;Po prenose pripocitam 30 k dlzke paketu

        mov      ECBs.FragSiz,ax	;V AX je dlzka dat

        mov      si,offset ECBs		;co je v podstate dlzka paketu
        mov      word ptr [si+4],0	;Adresa ECB pre vysielanie do SI
        mov      word ptr [si+6],0	;Nie je definovana ESR
        mov      word ptr [si+22h],1	;frag count=1, (len jeden fragment)

        mov      bx,03h			;Posli paket - sluzba 3
        push     si			;Uschovaj si registre
        push     es			;Uschovaj si registre
        int      7Ah			;Posielam paket cez IPX
        pop      es			;Obnov registre
        pop      si			;Obnov registre

neodeslal:
        cmp     byte ptr es:[si+8],0	;Polozka ECB je prave pouzivana
        jne     neodeslal		;Cakaj pokial sa paket neodosle
        mov     dx,usedsocket		;daj cislo soketu do DX
        mov     bx,01h			;Sluzba uzatvor soket
        push    es
        push    si
        int     7Ah			;Uloz si adresu ECB a zavolaj IPX pre
        pop     si			;uzatvorenie soketu
        pop     es			;Obnov adresu ECB v ES:SI

        cmp     byte ptr es:[si+9],0	;ECB CompletionCode
        je      vseok			;Zisti, ci bol paket odoslany v poriadku

        mov     dx,offset sdel3		;Do DX adresu oznamu
        jmp     error			;a skoc na ohlasenie chyby
vseok:  mov     ax,4C00h		;Vrat sa do DOSu
        int     21h			;Navratovy kon je OK=0

error:  mov     ah,09h			;Ukoncenie programu pri chybe
        int     21h			;Vytlac na obrazovku chybove hlasenie
        mov     ax,4C01h		;Vrat sa do DOSu
        int     21h			
	exitcode
	end